(** option properties *)

(** Chunxiao Lin @ 2006 *)

Set Implicit Arguments.
Unset Strict Implicit.


Inductive optionT (A:Type) : Type :=
  | SomeT : A -> optionT A
  | NoneT.

Implicit Arguments None [A].

Notation opt_predT :=
  (fun opt:optionT _ => 
    fun f =>
      match opt with
	| SomeT t => f t
	| NoneT => False
      end).

Notation opt_pred :=
  (fun opt:option _ => 
    fun f =>
      match opt with
	| Some t => f t
	| None => False
      end).

Notation opt_predT2 :=
  (fun opt:optionT _ => 
    fun opt':optionT _ => 
      fun f =>
	match opt, opt' with
	  | SomeT t, SomeT t' => f t t'
	  | _, _ => False
	end).

Definition opt_predT' (A : Type) (opt : optionT A) (f : A -> Prop) :=
  match opt with
    | SomeT t => f t
    | NoneT => False
  end.

Definition opt_pred' (A : Set) (opt : option A) (f : A -> Prop) :=
  match opt with
    | Some t => f t
    | None => False
  end.

Definition opt_predT2' (A : Type) (opt opt' : optionT A) (f : A -> A -> Prop) :=
  match opt, opt' with
    | SomeT t, SomeT t' => f t t'
    | _, _ => False
  end.
